#include "cuda_runtime.h"
#include "device_launch_parameters.h"

#include <stdio.h>
#include <time.h>

#define N 1024

void serial_matrix_mul(float *a, float *b, float *c, int n)
{
	for(int i=0;i<n;i++){
		for(int j=0;j<n;j++){
			for(int k=0; k<n; k++){
           		c[i*n+j] += a[i*n+k]*b[k*n+j];
			}
		}
	}
}

__global__ void matrix_mul(float *a, float *b, float *c)
{
	//write your code here

}

int main()
{
    clock_t start,end;

    //Host arrays
    float *a, *b, *c;
    int size = N*N* sizeof( float );

	
     
    //Allocate memory in CPU
    a = (float *)malloc( size);
    b = (float *)malloc( size);
    c = (float *)malloc( size);
	

     //initialize the arrays
    for( int i = 0; i < N; i++ )
    {
        for(int j =0 ; j < N; j++ ){
       	    a[i*N+j] = b[i*N+j] = i+j;
            c[i*N+j] = 0;
	   }
    }
	
	start = clock();
    //serial matrix multiplication
    serial_matrix_mul(a, b, c, N);

	end = clock();

    printf( "c[0] = %d\n",0,c[0] );
    printf( "c[%d] = %d\n", N*N-1, c[N*N-1] );

    

    float time1 = ((float)(end-start))/CLOCKS_PER_SEC;
    printf("Serial: %f seconds\n",time1);

	
	float* serial_result;
	serial_result = (float *)malloc(size);
	//clear the results
    for (int i = 0; i < N; i++){
		for(int j = 0; j< N; j++){
			serial_result[i*N+j] = c[i*N+j];
			c[i*N+j] = 0;
		}
    }

   

    //Device arrays
    float *d_a, *d_b, *d_c;


    //Allocate memory in GPU
    cudaMalloc( (void **) &d_a, size );
    cudaMalloc( (void **) &d_b, size );
    cudaMalloc( (void **) &d_c, size );

	 start = clock();

	//*********************Strat your code here****************//
	//Copy data from CPU to GPU (arrays a, and b)

   

    
   	//Call kernel


	//Copy result form CPU to GPU (array c)
    


	//**********************End your code here******************/

	end = clock();

    printf( "c[0] = %d\n",0,c[0] );
    printf( "c[%d] = %d\n", N*N-1, c[N*N-1] );


    cudaFree( d_a );
    cudaFree( d_b );
    cudaFree( d_c );
    
	//checking the results
    for (int i = 0; i < N; i++){
        for(int j = 0; j< N; j++){
	       if(serial_result[i*N+j] != c[i*N+j]){
                printf("Error!, wrong results in: element %d, %d",i,j );
			     break;
		  }
	   }
    }
  	
  
    float time2 = ((float)(end-start))/CLOCKS_PER_SEC;
    printf("CUDA: %f seconds, Speedup: %f\n",time2, time1/time2);

    return 0;
} 
